#--
# This code is automatically generated, do not modify the content !!!
#++
# UESActivityStateTemplate is a service that provides operations related to activity state templates.
# 
# <tt><b>since</b></tt> UES8-07
class Ues::Core::Workflow::UESActivityStateTemplate
  private_class_method :new

  BE_ACTIVITY_STATE_TEMPLATE_CODE = Java::cz.ues.core.workflow.UESActivityStateTemplate::BE_ACTIVITY_STATE_TEMPLATE_CODE #:nodoc:

  # URI of UESActivityStateTemplate business entity.
  BETYPE_ACTIVITY_STATE_TEMPLATE = Java::cz.ues.core.workflow.UESActivityStateTemplate::BETYPE_ACTIVITY_STATE_TEMPLATE


# Creates a new activity state template on the specified activity template. At least, its future name and type
# have to be specified in this command.
# 
# <tt><b>param</b></tt> activityTemplateUri UESURI of the activity template the new activity state template is to be created on.
# 
# <tt><b>param</b></tt> activityStateTemplate Object containing attributes of the new activity state template.
# 
# <tt><b>return</b></tt> UESURI of the new activity state template.
# 
# <tt><b>throws</b></tt> UESActivityStateTemplateRTException
# 
# <tt><b>since</b></tt> UES8-07
  def self.create(activityTemplateUri, activityStateTemplate = nil)
    activityTemplateUri = Ues::Core::Commons::Uri::UESURI.new(activityTemplateUri).to_java
    activityStateTemplate = Ues::Core::Workflow::UESActivityStateTemplateCreate.new(activityStateTemplate).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.UESActivityStateTemplate.java_class)
    _r = _s.create(activityTemplateUri, activityStateTemplate)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# Returns attributes of the specified activity state template.
# 
# <tt><b>param</b></tt> activityStateTemplateUri UESURI of the activity state template whose attributes are to be returned.
# 
# <tt><b>return</b></tt> Object with attributes of the activity state template.
# 
# <tt><b>throws</b></tt> UESActivityStateTemplateRTException
# 
# <tt><b>since</b></tt> UES8-07
  def self.getAttributes(activityStateTemplateUri)
    activityStateTemplateUri = Ues::Core::Commons::Uri::UESURI.new(activityStateTemplateUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.UESActivityStateTemplate.java_class)
    _r = _s.getAttributes(activityStateTemplateUri)
    if (_r != nil) then _r = Ues::Core::Workflow::UESActivityStateTemplateAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Workflow::UESActivityStateTemplate
    alias attributes getAttributes
  end

# Sets attributes of an activity state template. This command cannot modify the type.
# 
# <tt><b>param</b></tt> activityStateTemplateUri UESURI of the activity state template whose attributes are to be modified.
# 
# <tt><b>param</b></tt> activityStateTemplate Object containing new attributes of the activity state template.
# 
# <tt><b>return</b></tt> UESURI of the modified activity state template.
# 
# <tt><b>throws</b></tt> UESActivityStateTemplateRTException
# 
# <tt><b>since</b></tt> UES8-07
  def self.setAttributes(activityStateTemplateUri, activityStateTemplate = nil)
    activityStateTemplateUri = Ues::Core::Commons::Uri::UESURI.new(activityStateTemplateUri).to_java
    activityStateTemplate = Ues::Core::Workflow::UESActivityStateTemplateSetAttributes.new(activityStateTemplate).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.UESActivityStateTemplate.java_class)
    _r = _s.setAttributes(activityStateTemplateUri, activityStateTemplate)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Workflow::UESActivityStateTemplate
    alias set_attributes setAttributes
  end

# Deletes the specified activity state template. It it not possible to delete the entry or the exit state
# template, or a state template used in a condition or an action, or if it is important for the system
# according to its type.
# 
# <tt><b>param</b></tt> activityStateTemplateUri UESURI of the activity state template which is to be deleted.
# 
# <tt><b>throws</b></tt> UESActivityStateTemplateRTException
# 
# <tt><b>since</b></tt> UES8-07
  def self.delete(activityStateTemplateUri)
    activityStateTemplateUri = Ues::Core::Commons::Uri::UESURI.new(activityStateTemplateUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.UESActivityStateTemplate.java_class)
    _r = _s.delete(activityStateTemplateUri)
    
    return _r
  end

# Returns a list of activity state templates for the specified activity template according to entered criteria.
# Criteria are defined using query. The command does not return all activity state templates, only a sublist.
# The list of returned activity state templates can be filtered by the name, code, type, entryState, exitState
# and order. The list is sorted by the attribute order (and by name in case orders are equal) of an activity
# state template by default, or it can be sorted arbitrarily by any of activity state template attributes usable
# for filtering or by combinations of such attributes. See the UES query documentation for more information.
# 
# <tt><b>param</b></tt> activityTemplateUri UESURI of the activity template whose activity state templates are to be listed.
# 
# <tt><b>param</b></tt> criteria Object containing paging and filtering criteria.
# 
# <tt><b>return</b></tt> List of Objects representing activity state templates (the same objects as in the command getAttributes).
# 
# <tt><b>see</b></tt> <a href="https://uu.unicornuniverse.eu/ues/sesm?&SessFree=ues:UNI-BT:UES.DOC%2FCMD_V1%2FUESQUERY" target="_blank">
# UESQuery Documentation.</a>
# 
# <tt><b>throws</b></tt> UESActivityStateTemplateRTException
# 
# <tt><b>since</b></tt> UES8-07
  def self.getActivityStateTemplateList(activityTemplateUri, criteria = nil)
    activityTemplateUri = Ues::Core::Commons::Uri::UESURI.new(activityTemplateUri).to_java
    criteria = Ues::Core::Workflow::UESActivityStateTemplateGetActivityStateTemplateList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.workflow.UESActivityStateTemplate.java_class)
    _r = _s.getActivityStateTemplateList(activityTemplateUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Workflow::UESActivityStateTemplate
    alias activity_state_template_list getActivityStateTemplateList
  end
end
