#--
# This code is automatically generated, do not modify the content !!!
#++
class Ues::Digitalworkspace::Calendar::UESCalendar
  private_class_method :new


# Returns list of digital workspace calendar blocks for the specified user according to the specified parameters timeMin and timeMax.
# The maximum time difference between UESCalendarGetBusyTimeList#timeMin timeMin and UESCalendarGetBusyTimeList#timeMax timeMax
# is six weeks.
# 
# <tt><b>param</b></tt> roleUri URI of the role, access role or personal role. User's list of time blocks in the calendar is derived from the primary cast in case that role is entered and UESCalendarGetBusyTimeList#accessRoleUri accessRoleUri is not. User is known in case that access role or personal role is entered. Parameter must be filled, otherwise the command fails
# 
# <tt><b>param</b></tt> criteria Object containing criteria for listing busy time blocks.
# 
# <tt><b>return</b></tt> list of digital workspace calendar blocks for the specified users. Items in the list are returned according to the entered timeMin and timeMax. Each item contains UESCalendarBusyTimeAttributes.
# 
# <tt><b>since</b></tt> UES8-07
  def self.getBusyTimeList(roleUri, criteria = nil)
    roleUri = Ues::Core::Commons::Uri::UESURI.new(roleUri).to_java
    criteria = Ues::Digitalworkspace::Calendar::UESCalendarGetBusyTimeList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.digitalworkspace.calendar.UESCalendar.java_class)
    _r = _s.getBusyTimeList(roleUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Digitalworkspace::Calendar::UESCalendar
    alias busy_time_list getBusyTimeList
  end
end
