#--
# This code is automatically generated, do not modify the content !!!
#++
class Ues::Digitalworkspace::Calendar::UESRoleCalendar #:nodoc:
  private_class_method :new


# This command returns a list of calendar entries for the specified role. Use personal access role for the whole user's calendar. The
# command does not return all entries, only a sublist. The list can contain two types of entries. EVENT type represents a caledar event
# with all known information. On the other hand BUSY type represent only limited information about role's events - it represents block of
# busy time with no detail information. BUSY type entries are returned when there are not sufficient rights for reading the role's
# calendar. The list of calendar entries can be filtered by most of the entry attributes, see the UESRoleCalendarEntryAttributes
# documentation for more information. The list is sorted by the start time of an event (dateStart attribute) by default, or it can be
# sorted arbitrarily by any of the entry attributes usable for the filtering or these attributes combinations. See the UES query
# documentation for more information. Note that BUSY type entries contain the null value in most of the attributes, so they cannot be
# ordered by these attributes (entries appear at the end of the result list in the case of ordering by an attribute with null value).
# Also BUSY type entries are all filtered out when the ues query specifies a filter containing any of these null attributes.
# 
# <tt><b>param</b></tt> roleUri UESURI of the role whose calendar entries are retrieved
# 
# <tt><b>param</b></tt> criteria DTO containing criteria for listing calendar entries
# 
# <tt><b>return</b></tt> List of DTO representing calendar entries for the specified role roleUri.
# 
# <tt><b>throws</b></tt> UESCalendarRTException
# 
# <tt><b>since</b></tt> UES6-10
  def self.getCalendarEntryList(roleUri, criteria = nil)
    warn "[DEPRECATED: Ues::Digitalworkspace::Calendar::UESRoleCalendar.getCalendarEntryList] This class is used by iCal (use UESCalendar for common calendar using)"
    roleUri = Ues::Core::Commons::Uri::UESURI.new(roleUri).to_java
    criteria = Ues::Digitalworkspace::Calendar::UESRoleCalendarGetCalendarEntryList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.digitalworkspace.calendar.UESRoleCalendar.java_class)
    _r = _s.getCalendarEntryList(roleUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Digitalworkspace::Calendar::UESRoleCalendar
    alias calendar_entry_list getCalendarEntryList
  end
end
