#--
# This code is automatically generated, do not modify the content !!!
#++
# 
# 
# <tt><b>since</b></tt> UES7-10
class Ues::Digitalworkspace::Digitalworkspace::UESDigitalWorkspace
  private_class_method :new


# Returns list of active Digital Workspace Records in the specified Role's (or Access Role's) Digital Workspace. The command does not return all entries, only a sublist filtered by the query criteria. The list is sorted by default based on the date and name of each entry.
# 
# <tt><b>param</b></tt> roleUri (String, UESURI) - UESURI of the Role (or Access Role) for which digital workspace records will be returned.
# 
# <tt><b>param</b></tt> criteria (UESDigitalWorkspaceGetRecordList) (defaults to: null) - Specific options. Query (String) - Query for filtering and ordering of the result list. It is possible to filter the result list by name (String), dateFrom (String in ISO 8601 format), dateStart (String in ISO format), dateTo (String in ISO 8601 format), dateExpiration (String in ISO 8601 format), activityType (cz.ues.core.workflow.dto.UESActivityType), activityStateType (cz.ues.core.workflow.dto.UESActivityStateType), activityStateSubtype (cz.ues.core.workflow.dto.UESActivityStateSubtype), competentRoleName (String), executiveRoleName (String), artifactName (String), isNew (Boolean) and isUnread (Boolean).
# 
# <tt><b>return</b></tt> List of DTO representing digital workspace records.
# 
# <tt><b>see</b></tt> more information in <a href="https://uu.unicornuniverse.eu/ues/sesm?&SessFree=ues:UNI-BT:UES.DOC%2FCMD_V1%2FUESQUERY" target="_blank">uuQuery - Guideline</a>
# 
# <tt><b>throws</b></tt> UESDigitalWorkspaceRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.getActiveRecordList(roleUri, criteria = nil)
    roleUri = Ues::Core::Commons::Uri::UESURI.new(roleUri).to_java
    criteria = Ues::Digitalworkspace::Digitalworkspace::UESDigitalWorkspaceGetRecordList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.digitalworkspace.digitalworkspace.UESDigitalWorkspace.java_class)
    _r = _s.getActiveRecordList(roleUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Digitalworkspace::Digitalworkspace::UESDigitalWorkspace
    alias active_record_list getActiveRecordList
  end

# Returns list of archive Digital Workspace Records in the specified Role's (or Access Role's) Digital Workspace.The command does not return all entries, only a sublist filtered by the query criteria. The list is sorted by the date and name of an entry by default.
# or it can be sorted arbitrarily by any of entry attributes usable for the filtering or these attributes combinations.
# 
# <tt><b>param</b></tt> role_uri (String, UESURI) - UESURI of the Role (or Access Role) for which digital workspace records will be returned.
# 
# <tt><b>param</b></tt> criteria (DigitalWorkspaceGetRecordList) (defaults to: null) - Specific options. Query (String) - Query for filtering and ordering of the result list. It is possible to filter the result list by name (String), dateFrom (String in ISO 8601 format), dateStart (String in ISO format), dateTo (String in ISO 8601 format), dateCompleted (String in ISO 8601 format), dateExpiration (String in ISO 8601 format), activityType (cz.ues.core.workflow.dto.UESActivityType), activityStateType (cz.ues.core.workflow.dto.UESActivityStateType), activityStateSubtype (cz.ues.core.workflow.dto.UESActivityStateSubtype), competentRoleName (String), executiveRoleName (String) and artifactName (String).
# 
# <tt><b>return</b></tt> Entry list of DTO representing digital workspace records.
# 
# <tt><b>see</b></tt> more information in <a href="https://uu.unicornuniverse.eu/ues/sesm?&SessFree=ues:UNI-BT:UES.DOC%2FCMD_V1%2FUESQUERY" target="_blank">uuQuery - Guideline</a>
# 
# <tt><b>throws</b></tt> UESDigitalWorkspaceRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.getArchiveRecordList(roleUri, criteria = nil)
    roleUri = Ues::Core::Commons::Uri::UESURI.new(roleUri).to_java
    criteria = Ues::Digitalworkspace::Digitalworkspace::UESDigitalWorkspaceGetRecordList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.digitalworkspace.digitalworkspace.UESDigitalWorkspace.java_class)
    _r = _s.getArchiveRecordList(roleUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Digitalworkspace::Digitalworkspace::UESDigitalWorkspace
    alias archive_record_list getArchiveRecordList
  end

# Configures records settings of DW.
# 
# <tt><b>param</b></tt> recordUri - UESURI of the DW record for which digital attributes will be changed.
# 
# <tt><b>param</b></tt> attrs - DTO containing DWRecords settings.
# 
# <tt><b>return</b></tt> UESURI of DWRecord
# 
# <tt><b>since</b></tt> UES8-19
  def self.setRecordAttributes(recordUri, attrs = nil)
    recordUri = Ues::Core::Commons::Uri::UESURI.new(recordUri).to_java
    attrs = Ues::Digitalworkspace::Digitalworkspace::UESDigitalWorkspaceSetRecordAttributes.new(attrs).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.digitalworkspace.digitalworkspace.UESDigitalWorkspace.java_class)
    _r = _s.setRecordAttributes(recordUri, attrs)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Digitalworkspace::Digitalworkspace::UESDigitalWorkspace
    alias set_record_attributes setRecordAttributes
  end
end
