#--
# This code is automatically generated, do not modify the content !!!
#++
class Ues::Digitalworkspace::Sync::Ical::UESiCal #:nodoc:
  private_class_method :new


# The operation for export Role calendar to <a href="http://www.ietf.org/rfc/rfc2445.txt">iCal (RFC2445)<a> data format. The roleUri or
# iCalParameters could be used to limit exported records.
# 
# 
# 
# This command does not require any special access rights, the UES command UESRoleCalendar is used for read of the calendar records and
# provides the internal authorization.
# 
# 
# <tt><b>param</b></tt> roleUri - the UESRole URI used to find Role-Calendar. Typically the UESPerson URI is used to export all user calendar entries.
# 
# <tt><b>param</b></tt> parameters the special attributes for parameterization of the export. Or may be used NULL to use the default values.
# 
# <tt><b>return</b></tt> iCal-text export of the Role Calendar. It is encoded in UTF-8 format, as it is defined by iCal specification as default data
# characterset.
# 
# <tt><b>since</b></tt> UES7-01
  def self.getCalendar(roleUri, parameters = nil)
    roleUri = Ues::Core::Commons::Uri::UESURI.new(roleUri).to_java
    parameters = Ues::Digitalworkspace::Sync::Ical::UESiCalGetCalendar.new(parameters).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.digitalworkspace.sync.ical.UESiCal.java_class)
    _r = _s.getCalendar(roleUri, parameters)
    
    return _r
  end
  class << Ues::Digitalworkspace::Sync::Ical::UESiCal
    alias calendar getCalendar
  end

# 
# 
# Creates an object (data structure) used for iCalendar publication. This method must
# be invoked before attributes are obtained.
# 
# 
# 
# Current implementation of UESiCal service requires that used main entity is personal
# role of current authenticated user. If it is necessary to extend this behavior, please
# send a request.
# 
# <tt><b>param</b></tt> personalRoleUri UESURI of personal role of current authenticated user.
# 
# <tt><b>return</b></tt> UESURI of created object.
# 
# <tt><b>throws</b></tt> UESICalRTException If data structure cannot be created.
# 
# <tt><b>since</b></tt> UES7-10
  def self.create(personalRoleUri)
    personalRoleUri = Ues::Core::Commons::Uri::UESURI.new(personalRoleUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.digitalworkspace.sync.ical.UESiCal.java_class)
    _r = _s.create(personalRoleUri)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# 
# 
# Returns iCalendar attributes for specified personal role. This method doesn't return
# any calendar data. It returns only meta data related to calendar.
# 
# 
# 
# Current implementation of UESiCal service requires that used main entity is personal
# role of current authenticated user. If it is necessary to extend this behavior, please
# send a request.
# 
# <tt><b>param</b></tt> personalRoleUri UESURI of personal role of current authenticated user.
# 
# <tt><b>return</b></tt> iCalendar attributes for specified personal role or the value <code>null</code> if no
# such attributes exists.
# 
# <tt><b>since</b></tt> UES7-10
  def self.getAttributes(personalRoleUri)
    personalRoleUri = Ues::Core::Commons::Uri::UESURI.new(personalRoleUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.digitalworkspace.sync.ical.UESiCal.java_class)
    _r = _s.getAttributes(personalRoleUri)
    if (_r != nil) then _r = Ues::Digitalworkspace::Sync::Ical::UESiCalAttributes.new(_r) end
    return _r
  end
  class << Ues::Digitalworkspace::Sync::Ical::UESiCal
    alias attributes getAttributes
  end

# 
# 
# Sets diary publication access state.
# 
# 
# 
# Current implementation of UESiCal service requires that used main entity is personal
# role of current authenticated user. If it is necessary to extend this behavior, please
# send a request.
# 
# <tt><b>param</b></tt> personalRoleUri UESURI of personal role of current authenticated user.
# 
# <tt><b>param</b></tt> state DTO which describes credentials state.
# 
# <tt><b>throws</b></tt> UESICalRTException Thrown if the user has no iCalendar account.
# 
# <tt><b>since</b></tt> UES7-10
  def self.setAccessState(personalRoleUri, state = nil)
    personalRoleUri = Ues::Core::Commons::Uri::UESURI.new(personalRoleUri).to_java
    if ((!state.java_kind_of?Java::java.lang.Object) && (state.class.method_defined?"to_java")) then state = state.to_java end
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.digitalworkspace.sync.ical.UESiCal.java_class)
    _r = _s.setAccessState(personalRoleUri, state)
    
    return _r
  end
  class << Ues::Digitalworkspace::Sync::Ical::UESiCal
    alias set_access_state setAccessState
  end

# Sets credentials to iCalendar account. Invocation of this method changes access token
# and therefore it affects the iCalendar URL.
# 
# 
# 
# Current implementation of UESiCal service requires that used main entity is personal
# role of current authenticated user. If it is necessary to extend this behavior, please
# send a request.
# 
# 
# 
# The parameter credentials doesn't require current credentials because this command
# relies on authorization. When no new credentials are specified, the command generates
# appropriate credentials itself.
# 
# <tt><b>param</b></tt> personalRoleUri UESURI of personal role of current authenticated user.
# 
# <tt><b>param</b></tt> credentials DTO with new credentials.
# 
# <tt><b>throws</b></tt> UESICalRTException Thrown if the user has no iCalendar account.
# 
# <tt><b>since</b></tt> UES7-10
  def self.setCredentials(personalRoleUri, credentials = nil)
    personalRoleUri = Ues::Core::Commons::Uri::UESURI.new(personalRoleUri).to_java
    if ((!credentials.java_kind_of?Java::java.lang.Object) && (credentials.class.method_defined?"to_java")) then credentials = credentials.to_java end
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.digitalworkspace.sync.ical.UESiCal.java_class)
    _r = _s.setCredentials(personalRoleUri, credentials)
    
    return _r
  end
  class << Ues::Digitalworkspace::Sync::Ical::UESiCal
    alias set_credentials setCredentials
  end

# 
# 
# Deletes data structure used for synchronization of digital workspace calendar.
# 
# 
# 
# Current implementation of UESiCal service requires that used main entity is personal
# role of current authenticated user. If it is necessary to extend this behavior, please
# send a request.
# 
# <tt><b>param</b></tt> personalRoleUri UESURI of personal role of current authenticated user.
# 
# <tt><b>throws</b></tt> UESICalRTException Thrown if some data cannot be deleted.
# 
# <tt><b>since</b></tt> UES7-10
  def self.delete(personalRoleUri)
    personalRoleUri = Ues::Core::Commons::Uri::UESURI.new(personalRoleUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.digitalworkspace.sync.ical.UESiCal.java_class)
    _r = _s.delete(personalRoleUri)
    
    return _r
  end
end
