#--
# Extension used to override default generated API to be able to create new instance with plain String
# interpreted as file path of instance of File.
# It is used to construct UESFileHandler without need to explicitly use UESFileSource.
#++
class Ues::Platform::Commons::Lang::UESFileHandler

  class << self
    alias old_supports supports
  end
  def self.supports(params) #:nodoc:
    if ((params.java_kind_of?Java::java.lang.String) || (params.java_kind_of?String) || (params.java_kind_of?"".class))
      return true
    elsif ((params.java_kind_of?File) || (params.java_kind_of?Java::java.io.File))
      return true
    end
    return old_supports(params)
  end

  alias old_initialize initialize

  # Creates new instance of UESFileHandler. As parameter is accepted:
  # * Another instance of UESFileHandler
  # * Instance of Java object cz.ues.platform.commons.lang.UESFileHandler
  # * String representing file path
  # * File or instance of java.io.File
  # * Ruby hash containing some of following parameters:
  #   * file (alias arg0) - File or instance of java.io.File
  #   * fileName (alias arg1) - String or instance of java.lang.String
  #   * fileSource (alias arg2) - Instance of cz.ues.platform.commons.lang.UESFileSource
  def initialize(params=nil)
    if ((params != nil) && ((params.java_kind_of?Java::java.lang.String) || (params.java_kind_of?String) || (params.java_kind_of?"".class)))
      source = Java::cz.ues.platform.commons.lang.UESFileSource.new(Java::java.io.File.new(params))
      @dtoValue = Java::cz.ues.platform.commons.lang.UESFileHandler.new(source)
    elsif ((params.java_kind_of?File))
      source = Java::cz.ues.platform.commons.lang.UESFileSource.new(Java::java.io.File.new(params.path))
      @dtoValue = Java::cz.ues.platform.commons.lang.UESFileHandler.new(source)
    elsif ((params.java_kind_of?Java::java.io.File))
      source = Java::cz.ues.platform.commons.lang.UESFileSource.new(params)
      @dtoValue = Java::cz.ues.platform.commons.lang.UESFileHandler.new(source)
    else
      old_initialize(params)
    end
  end
  
end
